local waitTable = {};
local currentSpec = 0;
local APDifference = 0;
local XPRequired = {100, 300, 325, 350, 375, 400, 425, 450, 525, 625, 750, 875, 1000, 6840, 8830, 11280, 14400, 18620, 24000, 30600, 39520, 50880, 64800, 82500, 105280, 138650, 182780, 240870, 315520, 417650, 546000, 718200, 946660, 1245840};
local playerClass;
AP = AP or {};

local specializations = 3;

AlternatePower_Frame:RegisterEvent("ADDON_LOADED");
AlternatePower_Frame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED");
AlternatePower_Frame:RegisterEvent("PLAYER_ENTER_COMBAT");
AlternatePower_Frame:RegisterEvent("PLAYER_LEAVE_COMBAT");

function AlternatePower_Frame:OnEvent(event, arg1)
    if event == "ADDON_LOADED" and arg1 == "AlternatePower" then
        if ArtifactTraits == nil then
            ArtifactTraits = {0, 0, 0, 0};
        end
        if ArtifactAP == nil then
            ArtifactAP = {0, 0, 0, 0};
        end
        UPDATE_wait(0.01, SetSpecAPTraits);
        UPDATE_wait(0.02, CalcAPDifference);
        UPDATE_wait(0.03, RefreshTraitsAvailible);
        _, _, playerClass = UnitClass("player");
        if playerClass == 11 then
            specializations = 4;
        elseif playerClass == 12 then
            specializations = 2;
            AlternatePower_Frame:SetWidth(204);
            Spec_3_Frame:Hide();
            Spec_4_Frame:Hide();
        else
            specializations = 3;
            AlternatePower_Frame:SetWidth(306);
            Spec_4_Frame:Hide();
        end

        AlternatePower_Frame:Show();
    else
        if event == "PLAYER_SPECIALIZATION_CHANGED" then
            UPDATE_wait(0.25, SetSpecAPTraits);
            UPDATE_wait(0.5, CalcAPDifference);
            UPDATE_wait(0.75, RefreshTraitsAvailible);
        elseif event == "PLAYER_ENTER_COMBAT" then
            AlternatePower_Frame:Hide();
        elseif event == "PLAYER_LEAVE_COMBAT" then
            AlternatePower_Frame:Show();
        end
    end
end


AlternatePower_Frame:SetScript("OnEvent", AlternatePower_Frame.OnEvent);

function UPDATE_wait(delay, func, ...)
    if (type(delay)~="number" or type(func)~="function") then
        return false;
    end
    AlternatePower_Frame:SetScript("onUpdate", function (self, elapse)
        local count = #waitTable;
        local i = 1;
        while(i<=count) do
            local waitRecord = tremove(waitTable, i);
            local d = tremove(waitRecord, 1);
            local f = tremove(waitRecord, 1);
            local p = tremove(waitRecord, 1);
            if (d > elapse) then
                tinsert(waitTable, i, {d-elapse, f, p});
                i = i + 1;
            else
                count = count - 1;
                f(unpack(p));
            end
        end
    end);
    tinsert(waitTable,{delay, func, {...}});
    return true;
end

function SetSpecAPTraits()
    currentSpec = GetSpecialization();
    local _, _, _, _, artifactXP, pointsSpent, _, _, _, _, _, _ = C_ArtifactUI.GetEquippedArtifactInfo();
    ArtifactAP[currentSpec] = artifactXP;
    ArtifactTraits[currentSpec] = pointsSpent;
end

function CalcAPDifference()
    APDifference = XPRequired[ArtifactTraits[currentSpec] + 1] - ArtifactAP[currentSpec];
end

function RefreshTraitsAvailible()
    currentSpec = GetSpecialization();
    altTraits = {0, 0, 0, 0};
    altTraitPercentages = {0, 0, 0, 0}
    altTraits[currentSpec] = 1;
    altTraitPercentages[currentSpec] = 0;
    for i = 1, specializations, 1 do
        if i ~= currentSpec then
            local xp = APDifference + ArtifactAP[i];
            while xp > 0 do
                local traitComparison = ArtifactTraits[i] + altTraits[i] + 1;
                if xp >= XPRequired[traitComparison] then
                    xp = xp - XPRequired[traitComparison];
                    altTraits[i] = altTraits[i] + 1;
                else
                    altTraitPercentages[i] = math.floor((xp / (XPRequired[traitComparison]) * 100));
                    xp = 0;
                end

                Spec_1_Title:SetText(1 and select(2, GetSpecializationInfo(1)) or "None");
                if ArtifactTraits[1] == 0 then
                    Spec1_1_Points:SetText("No Data");
                else
                    Spec_1_Points:SetText(altTraits[1].."."..altTraitPercentages[1].." ("..altTraits[1] + ArtifactTraits[1]..")");
                end

                Spec_2_Title:SetText(2 and select(2, GetSpecializationInfo(2)) or "None");
                if ArtifactTraits[2] == 0 then
                    Spec1_2_Points:SetText("No Data");
                else
                    Spec_2_Points:SetText(altTraits[2].."."..altTraitPercentages[2].." ("..altTraits[2] + ArtifactTraits[2]..")");
                end

                if specializations > 2 then
                    Spec_3_Title:SetText(3 and select(2, GetSpecializationInfo(3)) or "None");
                    if ArtifactTraits[3] == 0 then
                        Spec1_3_Points:SetText("No Data");
                    else
                        Spec_3_Points:SetText(altTraits[3].."."..altTraitPercentages[3].." ("..altTraits[3] + ArtifactTraits[3]..")");
                    end

                end
                if specializations > 3 then
                    Spec_4_Title:SetText(4 and select(2, GetSpecializationInfo(4)) or "None");
                    if ArtifactTraits[4] == 0 then
                        Spec1_4_Points:SetText("No Data");
                    else
                        Spec_4_Points:SetText(altTraits[4].."."..altTraitPercentages[4].." ("..altTraits[4] + ArtifactTraits[4]..")");
                    end
                end
            end
        end
    end


end